/**
 * @file   ventana.cpp
 *
 * @author X-Soldiers Team.
 * 
 * @brief  Fichero de implementacion de la clase Ventana.
 * 
 */

#include <boost/lexical_cast.hpp>

#include <iostream>
#include <vector>
#include <ctime>

#include "ventana.h"
#include "jugador.h"
#include "caja.h"

using namespace std;
int fase = 1;
int disparo = 0;
int vidaP1 = 5;
int vidaP2 = 5;
int dir= 0;
int dir2= 0;

Ventana::Ventana () : Gosu::Window(768, 680, false){
		
	
	/**Inicializamos las variables del cursor personalizado
	*/
		mouseX=input().mouseX();
		mouseY=input().mouseY();
	
	/** Cargamos tipo de fuente
	*/
		
		fuente = new Gosu::Font(graphics(), Gosu::sharedResourcePrefix() + L"../../media/fuente/anythingyouwant.ttf", 33, 0);
		fuentecred = new Gosu::Font(graphics(), Gosu::sharedResourcePrefix() + L"../../media/fuente/astonish.ttf", 33, 0);
		fuentevida = new Gosu::Font(graphics(), Gosu::sharedResourcePrefix() + L"../../media/fuente/fuentelcd.ttf", 33, 0);
	/** Cargamos los fondos de pantalla: mapas, menu y opciones
	*/
		mwinner = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/mapas/fondo_menu4.2.PNG");
		mcreditos = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/mapas/creditos.PNG");
		opciones = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/mapas/opciones.PNG");
		menu = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/mapas/fondo_menu3.2.PNG");
		mapa = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/mapas/arena2.0.png");
		mapa2 = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/mapas/acantilado.png");
		bala = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/bala.png");
		bala2 = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/bala.png");

		
	/** Inicializamos la caja de colisión para P1 y P2:
	 */
		cajaP1.x = 38;//+8
		cajaP1.y = 550;
		cajaP1.w = 10;
		cajaP1.h = 30;
		cajaP2.x = 728;//+8
		cajaP2.y = 48;
		cajaP2.w = 10;
		cajaP2.h = 30;

	/** Inicializamos todas las cajas del colisiones del mapa (paredes)
	 */
		cajaM1.x = 178;
		cajaM1.y = 14;
		cajaM1.w = 17;
		cajaM1.h = 140;
		cajaM2.x = 110;
		cajaM2.y = 35;
		cajaM2.w = 64;
		cajaM2.h = 20;
		cajaM3.x = 693;
		cajaM3.y = 14;
		cajaM3.w = 17;
		cajaM3.h = 140;
		cajaM4.x = 54;
		cajaM4.y = 46;
		cajaM4.w = 17;
		cajaM4.h = 140;
		
		cajaM5.x = 256;
		cajaM5.y = 51;
		cajaM5.w = 136;
		cajaM5.h = 36;
		cajaM6.x = 380;
		cajaM6.y = 51;
		cajaM6.w = 17;
		cajaM6.h = 163;
		cajaM7.x = 338;
		cajaM7.y = 145;
		cajaM7.w = 56;
		cajaM7.h = 68;
		cajaM8.x = 236;
		cajaM8.y = 209;
		cajaM8.w = 158;
		cajaM8.h = 5;
		cajaM9.x = 256;
		cajaM9.y = 145;
		cajaM9.w = 22;
		cajaM9.h = 65;
		
		cajaM10.x = 116;
		cajaM10.y = 128;
		cajaM10.w = 17;
		cajaM10.h = 137;
		
		cajaM11.x = 539;
		cajaM11.y = 61;
		cajaM11.w = 52;
		cajaM11.h = 10;
		cajaM12.x = 483;
		cajaM12.y = 71;
		cajaM12.w = 167;
		cajaM12.h = 14;
		cajaM13.x = 472;
		cajaM13.y = 86;
		cajaM13.w = 190;
		cajaM13.h = 56;
		
		cajaM14.x = 178;
		cajaM14.y = 216;
		cajaM14.w = 17;
		cajaM14.h = 163;
		
		cajaM15.x = 484;
		cajaM15.y = 214;
		cajaM15.w = 17;
		cajaM15.h = 163;
		
		cajaM16.x = 643;
		cajaM16.y = 214;
		cajaM16.w = 17;
		cajaM16.h = 160;
		
		cajaM17.x = 643;
		cajaM17.y = 210;
		cajaM17.w = 100;
		cajaM17.h = 6;
		
		cajaM18.x = 555;
		cajaM18.y = 222;
		cajaM18.w = 25;
		cajaM18.h = 85;
		
		cajaM19.x = 240;
		cajaM19.y = 254;
		cajaM19.w = 74;
		cajaM19.h = 54;
		cajaM20.x = 358;
		cajaM20.y = 254;
		cajaM20.w = 74;
		cajaM20.h = 54;
		
		cajaM21.x = 54;
		cajaM21.y = 243;
		cajaM21.w = 17;
		cajaM21.h = 135;
		cajaM22.x = 54;
		cajaM22.y = 334;
		cajaM22.w = 57;
		cajaM22.h = 47;
		cajaM23.x = 54;
		cajaM23.y = 314;
		cajaM23.w = 34;
		cajaM23.h = 22;
		
		cajaM25.x = 697;
		cajaM25.y = 258;
		cajaM25.w = 18;
		cajaM25.h = 142;
		
		cajaM26.x = 178;
		cajaM26.y = 374;
		cajaM26.w = 156;
		cajaM26.h = 5;
		
		cajaM27.x = 383;
		cajaM27.y = 374;
		cajaM27.w = 156;
		cajaM27.h = 5;
		
		cajaM28.x = 541;
		cajaM28.y = 374;
		cajaM28.w = 17;
		cajaM28.h = 156;
		cajaM29.x = 557;
		cajaM29.y = 451;
		cajaM29.w = 61;
		cajaM29.h = 33;
		cajaM30.x = 690;
		cajaM30.y = 451;
		cajaM30.w = 61;
		cajaM30.h = 33;
		
		cajaM24.x = 273;
		cajaM24.y = 423;
		cajaM24.w = 159;
		cajaM24.h = 4;
		
		cajaM31.x = 51;
		cajaM31.y = 451;
		cajaM31.w = 25;
		cajaM31.h = 85;
		
		cajaM32.x = 118;
		cajaM32.y = 433;
		cajaM32.w = 17;
		cajaM32.h = 143;
		
		cajaM33.x = 178;
		cajaM33.y = 466;
		cajaM33.w = 17;
		cajaM33.h = 164;
		
		cajaM34.x = 314;
		cajaM34.y = 461;
		cajaM34.w = 78;
		cajaM34.h = 23;
		
		cajaM35.x = 445;
		cajaM35.y = 469;
		cajaM35.w = 59;
		cajaM35.h = 56;
		
		cajaM36.x = 237;
		cajaM36.y = 533;
		cajaM36.w = 159;
		cajaM36.h = 4;
		
		cajaM37.x = 626;
		cajaM37.y = 549;
		cajaM37.w = 62;
		cajaM37.h = 15;
		
		cajaM38.x = 240;
		cajaM38.y = 579;
		cajaM38.w = 128;
		cajaM38.h = 46;
		cajaM39.x = 222;
		cajaM39.y = 602;
		cajaM39.w = 40;
		cajaM39.h = 28;
		
	 /** Inicializamos la caja de colisión para las balas. La posición dependerá del
	  estado en el que esté el juego */
		cajaBala.w = bala -> width();
		cajaBala.h = bala -> height();
		cajaBala2.w = bala2 -> width();
		cajaBala2.h = bala2 -> height();	
		
	
	/** Reiniciamos la velocidad inicial*/
		balaVelX = 0;
		balaVelY = 0;
		balaVel2X = 0;
		balaVel2Y = 0;
	
	
	/** Cargamos el personaje 1
	*/
		for(int i=0;i<3;i++){
			for(int j=0;j<4;j++){
				soldado1[i][j] = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/personaje/personajes.png",24*i,32*j,24,32);
			}
		}

	/** Cargamos el personaje 2, con la funcion loca
	*/
		// valores de la carga de imagenes del jugador2 serian, 6<i<9, 4<j<8
		for(int i=0;i<3;i++){
			for(int j=0;j<4;j++){
				soldado2[i][j] = new Gosu::Image(graphics(), Gosu::sharedResourcePrefix() + L"../../media/personaje/personajes.png",(24*6)+(24*i),(32*4)+(32*j),24,32);	
			}
		}
	/** Cargamos musicamenu
	*/	
		musicamenu=new Gosu::Song(Gosu::sharedResourcePrefix() + L"../../media/music/Surprise.wav");
	
	/** Cargamos musicajuego
	*/	
		musicajuego=new Gosu::Song(Gosu::sharedResourcePrefix() + L"../../media/music/bass.wav");
		musicawinner=new Gosu::Song(Gosu::sharedResourcePrefix() + L"../../media/music/Himno_aleg.wav");
	/** Inicializamos lo necesario
	*/

	Jugador1= new Jugador(30,550);
	Jugador2= new Jugador(720,48);

	/** Ponemos el juego en el estado menu
	*/
    	estadoActual = ESTADO_MENU;

}

Ventana::~Ventana(){
    // Liberamos los recursos
		delete mapa;
		delete menu;
		delete opciones;
		delete mwinner;
		delete mcreditos;
		delete bala;
		delete bala2;
		delete fuente;
		for(int i=0;i<3;i++){
			for(int j=0;j<4;j++){
				delete soldado1[i][j];
			}
		}
		for(int i=0;i<3;i++){
			for(int j=0;j<4;j++){
				delete soldado2[i][j];
			}
		}
		delete musicamenu;
		delete musicajuego;
		delete musicawinner;
		
}

void Ventana::ReiniciarPartida(){
    // Aqui la funcion para reiniciar la partida
     //esta funcion tenemos que modificarla para que sea capaz de reiniciar una partida si el usuario lo pide
    if (input().down(Gosu::kbM)){
		      vidaP1= 5;
		      vidaP2= 5;
		      estadoActual=ESTADO_MENU; 
		}
    
    }

void Ventana::update(){

    /**Calculamos la nueva posicion del cursor personalizado
	*/
	mouseX=input().mouseX();
	mouseY=input().mouseY();
	/** Cargamos la musica
	*/
	if(estadoActual == ESTADO_MENU){
		musicawinner -> stop();
		musicajuego -> stop();
		musicamenu -> play();
	}
	if(estadoActual == ESTADO_JUEGO){
		musicawinner -> stop();
		musicamenu -> stop();
		musicajuego -> play();
	}
	
	if(estadoActual == ESTADO_WINER){
		musicajuego -> stop();
		musicawinner -> play();
	}

	if(estadoActual == ESTADO_CREDITOS){
		musicamenu -> play();
	}

	if(estadoActual == ESTADO_OPCIONES){
		musicamenu -> play();
	}
	 /** ESTADO DISPARO */
	 /** En el estado disparo, la bala se mueve (lógicamente)*/
	if(estadoActual== ESTADO_DISPARO){
	    if (disparo==1){
	      cajaBala.x += balaVelX;
	      cajaBala.y += balaVelY;
	      /** COLISIONES CON JUGADOR 2**/
	
		if (cajaBala.colisionaCon(cajaP2)){
		  //Reducimos la vida del jugador2
		    vidaP2 --;
		    estadoActual = ESTADO_JUEGO;
		}
	      /** COLISIONES CON PAREDES BALA1**/
		// Paredes intermedias
		if (colisiona(cajaBala)){
		    estadoActual = ESTADO_JUEGO;
		}
		// Pared izquierda
		if(cajaBala.x < PARED_IZQUIERDA-15){
		    estadoActual = ESTADO_JUEGO;
		}

		// Pared derecha
		else if(cajaBala.x > PARED_DERECHA+20){ 
		    estadoActual = ESTADO_JUEGO;
		}

		// Pared superior
		else if(cajaBala.y < PARED_SUPERIOR){
		    estadoActual = ESTADO_JUEGO;
		}

		// límite de abajo
		else if(cajaBala.y > PARED_INFERIOR+30){
		    estadoActual = ESTADO_JUEGO;
		}
	    }
	    
	    if (disparo==2){
	      cajaBala2.x += balaVel2X;
	      cajaBala2.y += balaVel2Y;
	      /** COLISIONES CON JUGADOR 1**/
	
		if (cajaBala2.colisionaCon(cajaP1)){
		  //Reducimos la vida del jugador1
		    vidaP1 --;
		    estadoActual = ESTADO_JUEGO;
		}
	      /** COLISIONES CON PAREDES BALA2**/
		// Paredes intermedias
		if (colisiona(cajaBala2)){
		    estadoActual = ESTADO_JUEGO;
		}
		// Pared izquierda
		if(cajaBala2.x < PARED_IZQUIERDA-15){
		    estadoActual = ESTADO_JUEGO;
		}

		// Pared derecha
		else if(cajaBala2.x > PARED_DERECHA+20){ 
		    estadoActual = ESTADO_JUEGO;
		}

		// Pared superior
		else if(cajaBala2.y < PARED_SUPERIOR){
		    estadoActual = ESTADO_JUEGO;
		}

		// límite de abajo
		else if(cajaBala2.y > PARED_INFERIOR+30){
		    estadoActual = ESTADO_JUEGO;
		}
	    }
	  /** COMPRUEBA P1 CON CADA CAJA DEL MAPA Y REBOTA AL JUGADOR SI ESTA COLISIONANDO */
	  if (dir==1 && colisiona(cajaP1)){
	    cajaP1.y+=2;
	    Jugador1->PosicionY(Jugador1->PosicionY()+2);
	  }
	  if (dir==2 && colisiona(cajaP1)){
	    cajaP1.y-=2;
	    Jugador1->PosicionY(Jugador1->PosicionY()-2);
	  }
	  if (dir==3 && colisiona(cajaP1)){
	    cajaP1.x+=2;
	    Jugador1->PosicionX(Jugador1->PosicionX()+2);
	  }
	  if (dir==4 && colisiona(cajaP1)){
	    cajaP1.x-=2;
	    Jugador1->PosicionX(Jugador1->PosicionX()-2);
	  }
	 
	   /** COMPRUEBA P2 CON CADA CAJA DEL MAPA Y REBOTA AL JUGADOR SI ESTA COLISIONANDO */
	  if (dir2==1 && colisiona(cajaP2)){
	    cajaP2.y+=2;
	    Jugador2->PosicionY(Jugador2->PosicionY()+2);
	  }
	  if (dir2==2 && colisiona(cajaP2)){
	    cajaP2.y-=2;
	    Jugador2->PosicionY(Jugador2->PosicionY()-2);
	  }
	  if (dir2==3 && colisiona(cajaP2)){
	    cajaP2.x+=2;
	    Jugador2->PosicionX(Jugador2->PosicionX()+2);
	  }
	  if (dir2==4 && colisiona(cajaP2)){
	    cajaP2.x-=2;
	    Jugador2->PosicionX(Jugador2->PosicionX()-2);
	  }
	  
	/**Logica del movimiento del jugador 1
	*/  
	Jugador1->tiempofm();
	if(Jugador1->tiempoi()>=TIEMPO){
		if(input().down(Gosu::kbW))
		  dir=1;
		if(input().down(Gosu::kbS))
		  dir=2;
		if(input().down(Gosu::kbA))
		  dir=3;
		if(input().down(Gosu::kbD))
		  dir=4;
		if(input().down(Gosu::kbW) && !(colisiona(cajaP1)))//Boton W, hacia arriba J1
			{
				if(Jugador1->estado()==0)
					Jugador1->estado(2);
				else
					Jugador1->estado(0);

				if (Jugador1->PosicionY()-VELOCIDAD>=PARED_SUPERIOR){
					Jugador1->PosicionY(Jugador1->PosicionY()-VELOCIDAD);
					cajaP1.y -= VELOCIDAD ;
				}
				else{
					Jugador1->PosicionY(PARED_SUPERIOR);
					cajaP1.y = PARED_SUPERIOR;
				}

				Jugador1->tiempoim();
			}

		if(input().down(Gosu::kbS) && !(colisiona(cajaP1)))//Boton S, hacia abajo J1
			{
				if(Jugador1->estado()==6)
					Jugador1->estado(8);
				else
					Jugador1->estado(6);

				if (Jugador1->PosicionY()+VELOCIDAD<=PARED_INFERIOR){
					Jugador1->PosicionY(Jugador1->PosicionY()+VELOCIDAD);
					cajaP1.y += VELOCIDAD ;
				}
				else{
					Jugador1->PosicionY(PARED_INFERIOR);
					cajaP1.y = PARED_INFERIOR;
				}

				Jugador1->tiempoim();
			
			}
	
		if(input().down(Gosu::kbA) && !(colisiona(cajaP1)))//Boton A, hacia la izquierda J1
			{
				if(Jugador1->estado()==9)
					Jugador1->estado(11);
				else
					Jugador1->estado(9);

				if (Jugador1->PosicionX()-VELOCIDAD>=PARED_IZQUIERDA){
					Jugador1->PosicionX(Jugador1->PosicionX()-VELOCIDAD);
					cajaP1.x -= VELOCIDAD;
				}
				else{
					Jugador1->PosicionX(PARED_IZQUIERDA);
					cajaP1.x = PARED_IZQUIERDA+4;
				}
				Jugador1->tiempoim();

			}

		if(input().down(Gosu::kbD) && !(colisiona(cajaP1)))//Boton D, hacia la derecha J1
			{
				if(Jugador1->estado()==3)
					Jugador1->estado(5);
				else
					Jugador1->estado(3);

				if (Jugador1->PosicionX()+VELOCIDAD<=PARED_DERECHA){
					Jugador1->PosicionX(Jugador1->PosicionX()+VELOCIDAD);
					cajaP1.x += VELOCIDAD;
				}
				else{
					Jugador1->PosicionX(PARED_DERECHA-4);
					cajaP1.x = PARED_DERECHA;
				}
				Jugador1->tiempoim();

			}

		if(!input().down(Gosu::kbD) && !input().down(Gosu::kbA) && !input().down(Gosu::kbW) && !input().down(Gosu::kbS))		
		// Si no se pulsan los botones de movimiento, obligamos al personaje al estado basico de su posicion.
			{
				if(Jugador1->estado()==0 || Jugador1->estado()==2)
					Jugador1->estado(1);

				if(Jugador1->estado()==3 || Jugador1->estado()==5)
					Jugador1->estado(4);
				
				if(Jugador1->estado()==6 || Jugador1->estado()==8)
					Jugador1->estado(7);
		
				if(Jugador1->estado()==9 || Jugador1->estado()==11)
					Jugador1->estado(10);
			}

	}

	/**Logica del movimiento del jugador 2
	*/

	Jugador2->tiempofm();
	//if(Jugador2->tiempo()>=TIEMPO){
		Jugador2->tiempoim();
		if(input().down(Gosu::kbUp))
		  dir2=1;
		if(input().down(Gosu::kbDown))
		  dir2=2;
		if(input().down(Gosu::kbLeft))
		  dir2=3;
		if(input().down(Gosu::kbRight))
		  dir2=4;
		if(input().down(Gosu::kbUp) && !(colisiona(cajaP2))) //Flecha arriba, hacia arriba J2
		
		{
			if(Jugador2->estado()==0)
				Jugador2->estado(2);
			else
				Jugador2->estado(0);

			if (Jugador2->PosicionY()-VELOCIDAD>=PARED_SUPERIOR){
				Jugador2->PosicionY(Jugador2->PosicionY()-VELOCIDAD);
				cajaP2.y -= VELOCIDAD ;
			}
			else{
				Jugador2->PosicionY(PARED_SUPERIOR);
				cajaP2.y = PARED_SUPERIOR;
			}
				Jugador2->tiempoim();
		}

		if(input().down(Gosu::kbDown)&& !(colisiona(cajaP2)))//Flecha abajo, hacia abajo J2
		{
			if(Jugador2->estado()==6)
				Jugador2->estado(8);
			else
				Jugador2->estado(6);

			if (Jugador2->PosicionY()+VELOCIDAD<=PARED_INFERIOR){
				Jugador2->PosicionY(Jugador2->PosicionY()+VELOCIDAD);
				cajaP2.y += VELOCIDAD ;
			}
			else{
				Jugador2->PosicionY(PARED_INFERIOR);
				cajaP2.y = PARED_INFERIOR;
			}
				Jugador2->tiempoim();
		}
	
		if(input().down(Gosu::kbLeft) && !(colisiona(cajaP2)))//Flecha izquierda, hacia la izquierda J2
		{
			if(Jugador2->estado()==9)
				Jugador2->estado(11);
			else
				Jugador2->estado(9);

			if (Jugador2->PosicionX()-VELOCIDAD>=PARED_IZQUIERDA){
				Jugador2->PosicionX(Jugador2->PosicionX()-VELOCIDAD);
				cajaP2.x -= VELOCIDAD;
			}
			else{
				Jugador2->PosicionX(PARED_IZQUIERDA);
				cajaP2.x = PARED_IZQUIERDA+4;
			}
				Jugador2->tiempoim();
		}

		if(input().down(Gosu::kbRight)&& !(colisiona(cajaP2)))//Flecha derecha, hacia la derecha J2
		{
			if(Jugador2->estado()==3)
				Jugador2->estado(5);
			else
				Jugador2->estado(3);

			if (Jugador2->PosicionX()+VELOCIDAD<=PARED_DERECHA){
				Jugador2->PosicionX(Jugador2->PosicionX()+VELOCIDAD);
				cajaP2.x += VELOCIDAD;
			}
			else{
				Jugador2->PosicionX(PARED_DERECHA-4);
				cajaP2.x = PARED_DERECHA;
			}

				Jugador2->tiempoim();
		}


		if(!input().down(Gosu::kbRight) && !input().down(Gosu::kbLeft) && !input().down(Gosu::kbUp) && !input().down(Gosu::kbDown))		
		// Si no se pulsan los botones de movimiento, obligamos al personaje al estado basico de su posicion.
		{
			if(Jugador2->estado()==0 || Jugador2->estado()==2)
				Jugador2->estado(1);

			if(Jugador2->estado()==3 || Jugador2->estado()==5)
				Jugador2->estado(4);
				
			if(Jugador2->estado()==6 || Jugador2->estado()==8)
				Jugador2->estado(7);
		
			if(Jugador2->estado()==9 || Jugador2->estado()==11)
				Jugador2->estado(10);

		} 

	}

	/**ESTADO JUEGO */

	if(estadoActual == ESTADO_JUEGO){
	 	
	   if (vidaP1 == 0 || vidaP2 == 0)
	     estadoActual = ESTADO_WINER;
	   cajaBala.x = Jugador1->PosicionX()+10;
	   cajaBala.y = Jugador1->PosicionY()+20;
	   cajaBala2.x = Jugador2->PosicionX()+10;
	   cajaBala2.y = Jugador2->PosicionY()+20;
	   
	   
	  /** COMPRUEBA P1 CON CADA CAJA DEL MAPA Y REBOTA AL JUGADOR SI ESTA COLISIONANDO */
	  if (dir==1 && colisiona(cajaP1)){
	    cajaP1.y+=2;
	    Jugador1->PosicionY(Jugador1->PosicionY()+2);
	  }
	  if (dir==2 && colisiona(cajaP1)){
	    cajaP1.y-=2;
	    Jugador1->PosicionY(Jugador1->PosicionY()-2);
	  }
	  if (dir==3 && colisiona(cajaP1)){
	    cajaP1.x+=2;
	    Jugador1->PosicionX(Jugador1->PosicionX()+2);
	  }
	  if (dir==4 && colisiona(cajaP1)){
	    cajaP1.x-=2;
	    Jugador1->PosicionX(Jugador1->PosicionX()-2);
	  }
	 
	  /** COMPRUEBA P2 CON CADA CAJA DEL MAPA Y REBOTA AL JUGADOR SI ESTA COLISIONANDO */
	  if (dir2==1 && colisiona(cajaP2)){
	    cajaP2.y+=2;
	    Jugador2->PosicionY(Jugador2->PosicionY()+2);
	  }
	  if (dir2==2 && colisiona(cajaP2)){
	    cajaP2.y-=2;
	    Jugador2->PosicionY(Jugador2->PosicionY()-2);
	  }
	  if (dir2==3 && colisiona(cajaP2)){
	    cajaP2.x+=2;
	    Jugador2->PosicionX(Jugador2->PosicionX()+2);
	  }
	  if (dir2==4 && colisiona(cajaP2)){
	    cajaP2.x-=2;
	    Jugador2->PosicionX(Jugador2->PosicionX()-2);
	  }
	 
	/**Logica del movimiento del jugador 1
	*/ 
	Jugador1->tiempofm();
	if(Jugador1->tiempoi()>=TIEMPO){
		if(input().down(Gosu::kbW))
		  dir=1;
		if(input().down(Gosu::kbS))
		  dir=2;
		if(input().down(Gosu::kbA))
		  dir=3;
		if(input().down(Gosu::kbD))
		  dir=4;
		if(input().down(Gosu::kbW) && !(colisiona(cajaP1)))//Boton W, hacia arriba J1
			{
				if(Jugador1->estado()==0)
					Jugador1->estado(2);
				else
					Jugador1->estado(0);

				if (Jugador1->PosicionY()-VELOCIDAD>=PARED_SUPERIOR){
					Jugador1->PosicionY(Jugador1->PosicionY()-VELOCIDAD);
					cajaP1.y -= VELOCIDAD ;
				}
				else{
					Jugador1->PosicionY(PARED_SUPERIOR);
					cajaP1.y = PARED_SUPERIOR;
				}

				Jugador1->tiempoim();
			}

		if(input().down(Gosu::kbS) && !(colisiona(cajaP1)))//Boton S, hacia abajo J1
			{
				if(Jugador1->estado()==6)
					Jugador1->estado(8);
				else
					Jugador1->estado(6);

				if (Jugador1->PosicionY()+VELOCIDAD<=PARED_INFERIOR){
					Jugador1->PosicionY(Jugador1->PosicionY()+VELOCIDAD);
					cajaP1.y += VELOCIDAD ;
				}
				else{
					Jugador1->PosicionY(PARED_INFERIOR);
					cajaP1.y = PARED_INFERIOR;
				}

				Jugador1->tiempoim();
			
			}
	
		if(input().down(Gosu::kbA) && !(colisiona(cajaP1)))//Boton A, hacia la izquierda J1
			{
				if(Jugador1->estado()==9)
					Jugador1->estado(11);
				else
					Jugador1->estado(9);

				if (Jugador1->PosicionX()-VELOCIDAD>=PARED_IZQUIERDA){
					Jugador1->PosicionX(Jugador1->PosicionX()-VELOCIDAD);
					cajaP1.x -= VELOCIDAD;
				}
				else{
					Jugador1->PosicionX(PARED_IZQUIERDA);
					cajaP1.x = PARED_IZQUIERDA+4;
				}
				Jugador1->tiempoim();

			}

		if(input().down(Gosu::kbD) && !(colisiona(cajaP1)))//Boton D, hacia la derecha J1
			{
				if(Jugador1->estado()==3)
					Jugador1->estado(5);
				else
					Jugador1->estado(3);

				if (Jugador1->PosicionX()+VELOCIDAD<=PARED_DERECHA){
					Jugador1->PosicionX(Jugador1->PosicionX()+VELOCIDAD);
					cajaP1.x += VELOCIDAD;
				}
				else{
					Jugador1->PosicionX(PARED_DERECHA-4);
					cajaP1.x = PARED_DERECHA;
				}
				Jugador1->tiempoim();

			}

		if(!input().down(Gosu::kbD) && !input().down(Gosu::kbA) && !input().down(Gosu::kbW) && !input().down(Gosu::kbS))		
		// Si no se pulsan los botones de movimiento, obligamos al personaje al estado basico de su posicion.
			{
				if(Jugador1->estado()==0 || Jugador1->estado()==2)
					Jugador1->estado(1);

				if(Jugador1->estado()==3 || Jugador1->estado()==5)
					Jugador1->estado(4);
				
				if(Jugador1->estado()==6 || Jugador1->estado()==8)
					Jugador1->estado(7);
		
				if(Jugador1->estado()==9 || Jugador1->estado()==11)
					Jugador1->estado(10);
			}

	}

	/**Logica del movimiento del jugador 2
	*/

	Jugador2->tiempofm();
	//if(Jugador2->tiempo()>=TIEMPO){
		Jugador2->tiempoim();
		if(input().down(Gosu::kbUp))
		  dir2=1;
		if(input().down(Gosu::kbDown))
		  dir2=2;
		if(input().down(Gosu::kbLeft))
		  dir2=3;
		if(input().down(Gosu::kbRight))
		  dir2=4;
		if(input().down(Gosu::kbUp) && !(colisiona(cajaP2)))//Flecha arriba, hacia arriba J2
		
		{
			if(Jugador2->estado()==0)
				Jugador2->estado(2);
			else
				Jugador2->estado(0);

			if (Jugador2->PosicionY()-VELOCIDAD>=PARED_SUPERIOR){
				Jugador2->PosicionY(Jugador2->PosicionY()-VELOCIDAD);
				cajaP2.y -= VELOCIDAD ;
			}
			else{
				Jugador2->PosicionY(PARED_SUPERIOR);
				cajaP2.y = PARED_SUPERIOR;
			}
				Jugador2->tiempoim();
		}

		if(input().down(Gosu::kbDown)&& !(colisiona(cajaP2)))//Flecha abajo, hacia abajo J2
		{
			if(Jugador2->estado()==6)
				Jugador2->estado(8);
			else
				Jugador2->estado(6);

			if (Jugador2->PosicionY()+VELOCIDAD<=PARED_INFERIOR){
				Jugador2->PosicionY(Jugador2->PosicionY()+VELOCIDAD);
				cajaP2.y += VELOCIDAD ;
			}
			else{
				Jugador2->PosicionY(PARED_INFERIOR);
				cajaP2.y = PARED_INFERIOR;
			}
				Jugador2->tiempoim();
		}
	
		if(input().down(Gosu::kbLeft) && !(colisiona(cajaP2)))//Flecha izquierda, hacia la izquierda J2
		{
			if(Jugador2->estado()==9)
				Jugador2->estado(11);
			else
				Jugador2->estado(9);

			if (Jugador2->PosicionX()-VELOCIDAD>=PARED_IZQUIERDA){
				Jugador2->PosicionX(Jugador2->PosicionX()-VELOCIDAD);
				cajaP2.x -= VELOCIDAD;
			}
			else{
				Jugador2->PosicionX(PARED_IZQUIERDA);
				cajaP2.x = PARED_IZQUIERDA+4;
			}
				Jugador2->tiempoim();
		}

		if(input().down(Gosu::kbRight)&& !(colisiona(cajaP2)))//Flecha derecha, hacia la derecha J2
		{
			if(Jugador2->estado()==3)
				Jugador2->estado(5);
			else
				Jugador2->estado(3);

			if (Jugador2->PosicionX()+VELOCIDAD<=PARED_DERECHA){
				Jugador2->PosicionX(Jugador2->PosicionX()+VELOCIDAD);
				cajaP2.x += VELOCIDAD;
			}
			else{
				Jugador2->PosicionX(PARED_DERECHA-4);
				cajaP2.x = PARED_DERECHA;
			}

				Jugador2->tiempoim();
		}


		if(!input().down(Gosu::kbRight) && !input().down(Gosu::kbLeft) && !input().down(Gosu::kbUp) && !input().down(Gosu::kbDown))		
		// Si no se pulsan los botones de movimiento, obligamos al personaje al estado basico de su posicion.
		{
			if(Jugador2->estado()==0 || Jugador2->estado()==2)
				Jugador2->estado(1);

			if(Jugador2->estado()==3 || Jugador2->estado()==5)
				Jugador2->estado(4);
				
			if(Jugador2->estado()==6 || Jugador2->estado()==8)
				Jugador2->estado(7);
		
			if(Jugador2->estado()==9 || Jugador2->estado()==11)
				Jugador2->estado(10);

		}	  

	}

}

void Ventana::draw(){

	//Imprimimos el menu
	if(estadoActual == ESTADO_MENU)
	{
		
		//PINTAMOS FONDO
		menu ->draw(0,0,0);
		//fuente -> draw(L"X-SOLDIERS",200,50,0,2,2,0xff0000ff);
		fuente -> draw(L"JUGAR",300,400,0,1,1,0xff0000ff);
		fuente -> draw(L"OPCIONES",300,450,0,1,1,0xff0000ff);
		fuente -> draw(L"CREDITOS",300,500,0,1,1,0xff0000ff);
		fuente -> draw(L"SALIR",300,550,0,1,1,0xff0000ff/*0xffff0000*/);
	}

	//Imprimimos los creditos

	if(estadoActual == ESTADO_CREDITOS)
	{
		mcreditos ->draw(0,0,0);
		fuentecred -> draw(L"CREDITOS",350,5,0);
		fuentecred -> draw(L"X-Soldiers Team",225,100,0,2,2);
		fuentecred -> draw(L"Francisco Jose Reyes Sanchez",250,350,0);
		fuentecred -> draw(L"Manuel Jesus Roca Suarez",250,250,0);
		fuentecred -> draw(L"Alvaro Zaballa Fernandez",250,300,0);
		fuentecred -> draw(L"Volver",50,610,0,1,1,0xffff0000);
	}

	//Imprimimos las opciones
	if(estadoActual == ESTADO_OPCIONES)
	{
		opciones ->draw(0,0,0);
		fuentecred -> draw(L"CONTROLES",250,50,0,2,2,0xffff0000);
		fuentecred -> draw(L"Volver",50,600,0);
		fuentecred -> draw(L"PLAYER 1",160,150,0,2,2,0xfffffaaa);
		fuentecred -> draw(L"PLAYER 2",400,150,0,2,2,0xff0000ff);
		fuentecred -> draw(L"ESC: SALIR DEL JUEGO",100,550,0,1,1,0xffff0000);
		fuentecred -> draw(L"M: SALIR A MENU",400,550,0,1,1,0xffff0000);
	}
	//Imprimimos el ganador
	if(estadoActual == ESTADO_WINER){
		mwinner ->draw(0,0,0);
		if (vidaP2 == 0){
		    fuentecred -> draw(L"WINNER !!",200,0,0,4,4,0xffff0000);
		    fuentecred -> draw(L"PLAYER 1",300,550,0,2,2,0xfffffaaa);
		  
		}
		else if (vidaP1 == 0){
		    fuentecred -> draw(L"WINNER !!",200,0,0,4,4,0xffff0000);
		    fuentecred -> draw(L"PLAYER 2",300,550,0,2,2,0xff0000ff);    
		}
		
		if (fase == 1){
		    fase = 2;  
		}
		else {
		    fase = 1;
		}
		if (input().down(Gosu::kb2)){
		      vidaP1= 5;
		      vidaP2= 5;
		      estadoActual=ESTADO_JUEGO; 
		}
		if (input().down(Gosu::kbM)){
		      vidaP1= 5;
		      vidaP2= 5;
		      estadoActual=ESTADO_MENU; 
		}
	}
	
	if(estadoActual == ESTADO_JUEGO || estadoActual == ESTADO_DISPARO)
	{
	  //Imprimimos mapas
	  if (fase == 1){
	      mapa ->draw(0,0,0);
	  }
	  if (fase == 2){
	      mapa2 ->draw(0,0,0);
	  }

	// Mostramos J1
	switch(Jugador1->estado())
	{
		case 0:
			{
				soldado1[0][0] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 1:
			{
				soldado1[1][0] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 2:
			{
				soldado1[2][0] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 3:
			{
				soldado1[0][1] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 4:
			{
				soldado1[1][1] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 5:
			{
				soldado1[2][1] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 6:
			{
				soldado1[0][2] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 7:
			{
				soldado1[1][2] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 8:
			{
				soldado1[2][2] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 9:
			{
				soldado1[0][3] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 10:
			{
				soldado1[1][3] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
		case 11:
			{
				soldado1[2][3] -> draw(Jugador1->PosicionX(),Jugador1->PosicionY(),0);
				break;
			}
	}
	
	// Mostramos J2
	switch(Jugador2->estado())
	{
		case 0:
			{
				soldado2[0][0] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 1:
			{
				soldado2[1][0] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 2:
			{
				soldado2[2][0] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 3:
			{
				soldado2[0][1] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 4:
			{
				soldado2[1][1] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 5:
			{
				soldado2[2][1] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 6:
			{
				soldado2[0][2] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 7:
			{
				soldado2[1][2] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 8:
			{
				soldado2[2][2] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 9:
			{
				soldado2[0][3] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 10:
			{
				soldado2[1][3] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
		case 11:
			{
				soldado2[2][3] -> draw(Jugador2->PosicionX(),Jugador2->PosicionY(),0);
				break;
			}
	}
	
	  // Pintamos la bala
	  if (estadoActual== ESTADO_DISPARO){
	    if (disparo==1)
	      bala -> draw(cajaBala.x, cajaBala.y, 1);
	    if (disparo==2)
	      bala2 -> draw(cajaBala2.x, cajaBala2.y, 1);
	  }
	  // Mostramos HUD
	  fuentecred -> draw(L"PLAYER 1",80,640,0,1,1,0xfffffaaa);
	  fuentecred -> draw(L"NIVELES DE VIDA",310,640,0,1,1,0xffff0000);
	  fuentecred -> draw(L"PLAYER 2",605,640,0,1,1,0xff0000ff);  
	  fuentevida -> draw(boost::lexical_cast<wstring>(vidaP1),25, 640, 3);
	  fuentevida -> draw(boost::lexical_cast<wstring>(vidaP2),730, 640, 3);
	}
	 
}

void Ventana::buttonDown(Gosu::Button B){

   // Si se pulsa la tecla Escape, salimos
    if(B == Gosu::kbEscape){
        close();
    }
    // Si estamos en el estado juego y se pulsa el espacio dispara el jugador1
    // Comenzamos el movimiento de la bala
    if(estadoActual == ESTADO_JUEGO && (B == Gosu::kbSpace)){
        // Le aplicamos a la bala la direccion del soldado
        disparo=1;
	if(Jugador1->estado()==0 ||Jugador1->estado()==1 ||Jugador1->estado()==2){
        balaVelY = - VEL_BALA;
        balaVelX = 0;
	}
	if(Jugador1->estado()==6 ||Jugador1->estado()==7 ||Jugador1->estado()==8){
        balaVelY = VEL_BALA;
        balaVelX = 0;
	}
	if(Jugador1->estado()==9 ||Jugador1->estado()==10 ||Jugador1->estado()==11){
        balaVelY = 0;
        balaVelX = - VEL_BALA;
	}
	if(Jugador1->estado()==3 ||Jugador1->estado()==4 ||Jugador1->estado()==5){
        balaVelY = 0;
        balaVelX = VEL_BALA;
	}
        // Pasamos al estado de movimiento
        estadoActual = ESTADO_DISPARO;
    }
    // Si estamos en el estado juego y se pulsa el 0 dispara el jugador2
    // Comenzamos el movimiento de la bala
    if(estadoActual == ESTADO_JUEGO && (B == Gosu::kb0)){
        // Le aplicamos a la bala la direccion del soldado
        disparo=2;
	if(Jugador2->estado()==0 ||Jugador2->estado()==1 ||Jugador2->estado()==2){
        balaVel2Y = - VEL_BALA;
        balaVel2X = 0;
	}
	if(Jugador2->estado()==6 ||Jugador2->estado()==7 ||Jugador2->estado()==8){
        balaVel2Y = VEL_BALA;
        balaVel2X = 0;
	}
	if(Jugador2->estado()==9 ||Jugador2->estado()==10 ||Jugador2->estado()==11){
        balaVel2Y = 0;
        balaVel2X = - VEL_BALA;
	}
	if(Jugador2->estado()==3 ||Jugador2->estado()==4 ||Jugador2->estado()==5){
        balaVel2Y = 0;
        balaVel2X = VEL_BALA;
	}    
        // Pasamos al estado de movimiento
       	estadoActual = ESTADO_DISPARO;
    }

    
     if(B == Gosu::kb1){
       estadoActual=ESTADO_WINER;
    }
	else{
		
		//Si estamos en estado Menu
		if(estadoActual == ESTADO_MENU)
		{
			//Si pulsamos sobre JUGAR, pasamos a ESTADO_JUGAR
			
			if(B == Gosu::msLeft && mouseX > 300 && mouseX < 450 && mouseY > 400 && mouseY < 433){
				estadoActual= ESTADO_JUEGO;
			}
			//Si pulsamos sobre OPCIONES, pasamos a ESTADO_OPCIONES
			
			if(B == Gosu::msLeft && mouseX > 300 && mouseX < 495 && mouseY > 450 && mouseY < 483){
				estadoActual= ESTADO_OPCIONES;
			}
			//Si pulsamos sobre CREDITOS, pasamos a ESTADO_CREDITOS
			
			if(B == Gosu::msLeft && mouseX > 300 && mouseX < 500 && mouseY > 500 && mouseY < 533){
				estadoActual= ESTADO_CREDITOS;
			}
			//Si pulsamos sobre SALIR, cerramos la aplicacion
			
			if(B == Gosu::msLeft && mouseX > 300 && mouseX < 450 && mouseY > 550 && mouseY < 583){
				close();
			}
		}

		//Si estamos en estado Creditos
		if(estadoActual == ESTADO_CREDITOS)
		{
			if(B == Gosu::msLeft && mouseX > 50 && mouseX < 150 && mouseY > 600 && mouseY < 640)
			{
				estadoActual= ESTADO_MENU;
			}
		}


		//Si estamos en estado Opciones
		if(estadoActual == ESTADO_OPCIONES)
		{
			if(B == Gosu::msLeft && mouseX > 50 && mouseX < 150 && mouseY > 595 && mouseY < 630)
			{
				estadoActual= ESTADO_MENU;
			}
		}
 	}
}

bool Ventana::needsCursor() const{
    // Si devolvemos false, el cursor se esconde.
	if(estadoActual == ESTADO_JUEGO || estadoActual == ESTADO_DISPARO || estadoActual == ESTADO_WINER)
    	return false;
	else
		return true;
    }

bool Ventana::colisiona(Caja c){
   if (c.colisionaCon(cajaM1) ||(c.colisionaCon(cajaM2))||(c.colisionaCon(cajaM3)) ||(c.colisionaCon(cajaM4)) ||(c.colisionaCon(cajaM5)) ||(c.colisionaCon(cajaM6)) ||(c.colisionaCon(cajaM7)) ||(c.colisionaCon(cajaM8)) ||(c.colisionaCon(cajaM9)) ||(c.colisionaCon(cajaM10)) ||(c.colisionaCon(cajaM11)) ||(c.colisionaCon(cajaM12)) ||(c.colisionaCon(cajaM13))||(c.colisionaCon(cajaM14))||(c.colisionaCon(cajaM15)) ||(c.colisionaCon(cajaM16)) ||(c.colisionaCon(cajaM17)) ||(c.colisionaCon(cajaM18)) ||(c.colisionaCon(cajaM19)) ||(c.colisionaCon(cajaM20)) ||(c.colisionaCon(cajaM21)) ||(c.colisionaCon(cajaM22)) ||(c.colisionaCon(cajaM23)) ||(c.colisionaCon(cajaM24)) ||(c.colisionaCon(cajaM25))||(c.colisionaCon(cajaM26)) ||(c.colisionaCon(cajaM27)) ||(c.colisionaCon(cajaM28)) ||(c.colisionaCon(cajaM29)) ||(c.colisionaCon(cajaM30))||(c.colisionaCon(cajaM31)) ||(c.colisionaCon(cajaM32)) ||(c.colisionaCon(cajaM33)) ||(c.colisionaCon(cajaM34)) ||(c.colisionaCon(cajaM35))||(c.colisionaCon(cajaM36)) ||(c.colisionaCon(cajaM37)) ||(c.colisionaCon(cajaM38)) ||(c.colisionaCon(cajaM39)))        
    return true;
   else 
    return false; 
}
